﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "BaseWeaponClass.h"
#include "EndlessVendetta/EndlessVendettaCharacter.h"
#include "Components/CapsuleComponent.h"
#include "Kismet/GameplayStatics.h"


// Sets default values
ABaseWeaponClass::ABaseWeaponClass()
{
	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
}

// Called when the game starts or when spawned
void ABaseWeaponClass::BeginPlay()
{
	Super::BeginPlay();
	
	// Attempt to find the player character
	APlayerController* PlayerController = UGameplayStatics::GetPlayerController(this, 0);
	player = Cast<AEndlessVendettaCharacter>(PlayerController->GetCharacter());
	if (PlayerController)
	{
		if (player)
		{
			UE_LOG(LogTemp, Display, TEXT("BeginPlay: Player found."));
		}
		else
		{
			UE_LOG(LogTemp, Error, TEXT("BeginPlay: Player not found."));
		}
	}
	else
	{
		UE_LOG(LogTemp, Error, TEXT("BeginPlay: Player controller not found."));
	}
}

// Called every frame
void ABaseWeaponClass::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

void ABaseWeaponClass::TapFire()
{
	FHitResult outHit;
	FVector traceStart;
	FVector traceEnd;
	traceStart = player->GetActorLocation();
	traceEnd = traceStart + (player->GetActorForwardVector() * 50);
	UE_LOG(LogTemp, Display, TEXT("World: %s"), *GetWorld()->GetName());
	FCollisionQueryParams collisionParams;
	GetWorld()->LineTraceSingleByChannel(outHit, traceStart, traceEnd, ECC_Visibility, collisionParams);

	//Debug line to see where the trace hit
	DrawDebugLine(this->GetWorld(), traceStart, traceEnd, FColor::Red, true);
	if (outHit.bBlockingHit)
	{
		UE_LOG(LogTemp, Display, TEXT("Hit something"));
	}
	UE_LOG(LogTemp, Display, TEXT("BOOMBOOMBIMBAMBIM"));
}
